
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: syf_beh_addbeifs.c					*/
/* date		: Aug 28 1992						*/
/* version	: v102							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* content	: contains a specific function used to create a		*/
/*		  behaviour data structure				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H 
#include LOG_H 
#include BEH_H 

/* ###--------------------------------------------------------------### */
/* function	: syf_beh_addbeifs						*/
/* description	: create a BEIFS structure at the top the list		*/
/* called func.	: addptype, mbkalloc					*/
/* ###--------------------------------------------------------------### */

struct ptype *syf_beh_addbeifs (lastptype, abl)

struct ptype *lastptype;	/* pointer on the last ptype structure	*/
struct chain *abl;		/* condition's expression		*/

  {
  struct ptype *ptptype;
  struct syf_beifs *ptbeifs;

  ptbeifs           = (struct syf_beifs *) mbkalloc (sizeof(struct syf_beifs));
  ptbeifs->CND      = abl;
  ptbeifs->CNDTRUE  = NULL;
  ptbeifs->CNDFALSE = NULL;
  ptptype           = addptype (lastptype, BEH_BEIFS, (void *)ptbeifs);

  return (ptptype);
  }
